aboutsummaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorDaniel Lezcano <daniel.lezcano@linaro.org>2011-07-26 14:39:00 +0200
committerDaniel Lezcano <daniel.lezcano@linaro.org>2011-07-26 14:39:00 +0200
commit4b69978b0b91ed7c0878c3efca3eaa90e42c48f6 (patch)
tree52fc2f379c5714327e21c0704c23146680690092
parent712e3335c64299aeb4987ee3cee130e4a618ce0d (diff)
test the load of the cpu does not affect the frequency with 'powersave'
Signed-off-by: Daniel Lezcano <daniel.lezcano@linaro.org>
-rw-r--r--cpufreq/test_09.sh74
1 files changed, 74 insertions, 0 deletions
diff --git a/cpufreq/test_09.sh b/cpufreq/test_09.sh
new file mode 100644
index 0000000..ca05b11
--- /dev/null
+++ b/cpufreq/test_09.sh
@@ -0,0 +1,74 @@
+#!/bin/bash
+#
+# PM-QA validation test suite for the power management on ARM
+#
+# Copyright (C) 2011, Linaro Limited.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License
+# as published by the Free Software Foundation; either version 2
+# of the License, or (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+#
+# Contributors:
+# Daniel Lezcano <daniel.lezcano@linaro.org> (IBM Corporation)
+# - initial API and implementation
+#
+
+# URL : https://wiki.linaro.org/WorkingGroups/PowerManagement/Doc/QA/Scripts#test_09
+
+source ../include/functions.sh
+
+CPUBURN=../utils/cpuburn
+
+check_powersave() {
+
+ local cpu=$1
+ local minfreq=$(get_min_frequency $cpu)
+ local curfreq=$(get_frequency $cpu)
+
+ set_governor $cpu powersave
+
+ wait_latency $cpu
+ curfreq=$(get_frequency $cpu)
+
+ check "'powersave' sets frequency to $(frequnit $minfreq)" "test \"$curfreq\" == \"$minfreq\""
+ if [ "$?" != "0" ]; then
+ return 1
+ fi
+
+ $CPUBURN $cpu &
+ pid=$!
+
+ wait_latency $cpu
+ curfreq=$(get_frequency $cpu)
+ kill $pid
+
+ check "'powersave' frequency $(frequnit $minfreq) is fixed" "test \"$curfreq\" == \"$minfreq\""
+ if [ "$?" != "0" ]; then
+ return 1
+ fi
+
+ return 0
+}
+
+save_governors
+
+if [ $(id -u) != 0 ]; then
+ log_skip "run as non-root"
+ exit 0
+fi
+
+trap "restore_governors; sigtrap" SIGHUP SIGINT SIGTERM
+
+for_each_cpu check_powersave
+
+restore_governors